
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>javascript中小数转换为整数 / 憋错料</title>

    <meta name="description" content="javascript中小数转换为整数 还是去年的时候有同事随口问我在javascript中怎么把小数转换成整数(去掉小数位),当时我回答直接用parseInt.其实那时候也没有仔细考虑这个问题还有没有其他的方法.不过最近在看别人一篇博文里的代码时,发现他这么写代码 var random = (Math.random() * 2) | 0; // get random 0 or 1 我们都知道javascript的Number其实就是双精度浮点数,而Math.random() * 2 很明显随即出来的是[0 ~ 2)之间的小数,他通过">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">javascript中小数转换为整数</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>还是去年的时候有同事随口问我在javascript中怎么把小数转换成整数(去掉小数位)，当时我回答直接用parseInt。其实那时候也没有仔细考虑这个问题还有没有其他的方法。不过最近在看别人一篇博文里的代码时，发现他这么写代码</p>
<pre>var random = (Math.random() * 2) | 0; // get random 0 or 1</pre>
<p>我们都知道javascript的Number其实就是双精度浮点数，而Math.random() * 2 很明显随即出来的是[0 ~ 2)之间的小数，他通过与0或的方式，把小数部分去掉了，cool！</p>

<p>这种方式的原理就是利用<strong>javascript做位运算时(bitwise operation)会先把操作数通过无符号右移的方式变为32位整数</strong>，而与0进行按位或显然不会改变整数的值，所以可以通过这样的方式把小数转化成整数，去掉小数部分。所以我们应该能猜到 (true | 0)会得到1， &ldquo;123&rdquo;|0会得到123。同理，也可以通过 &amp;&nbsp;4294967295的方式来达到同样的目的。</p>

<p>其实还有好几种简单方法可以去掉小数部分把小数转化成整数，下面列出来</p>

<p>第二种：两次取反，同样是利用位操作转换原理。</p>
<pre>var integer = ~~decimal; // 4 = ~~4.123</pre>
<p>第三种：利用向上取整数与向下取整数的数学函数, Math.ceil和Math.floor</p>
<pre>var integer = decimal &gt;= 0 ? Math.floor(decimal) : Math.ceil(decimal);</pre>
<p>当然还有更复杂的方式，不过经过Robert Koritnik测试，还是与0或的方式更快，推荐大家使用:)</p>
<p>附上测试连接&nbsp;<a href="http://jsperf.com/truncating-decimals" rel="external nofollow noreferrer">http://jsperf.com/truncating-decimals</a></p>

<p>不过还是要提醒一下大家，第一种和第二种方式对操作数的范围有要求（因为是转换成32位整数），所以如果值本身超过了32位整数所能表示的范围，那么将会因为信息丢失而出现错误的结果。比如2147483648 | 0 的结果是-2147483648 。~~4294967296的结果是0。32位带符号整数最大是2147483647，所以这种方法要求小数的整数部分在-2147483648 到&nbsp;2147483647之间。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-13 03:41:22 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/strong/" title="strong">strong</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>javascript中小数转换为整数的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBGmOY0.html" rel="bookmark">&lbrack;转载&rsqb;JavaScript 中小数和大整数的精度丢失</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				标题: JavaScript 中小数和大整数的精度丢失作者: Demon链接: http://demon.tw/copy-paste/javascript-precision.html版权: 本博客的所有文章,都遵守“署名-非商业性使用-相同方式共享 2.5 中国大陆”协议条款. 先来看两个问题: 0.1 + 0.2 == 0.3; // false 9999999999999999 == 10000000000000000; // true 第一个问题是小数的精度问题,在业界不少博客里已有讨论			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPWX1m4.html" rel="bookmark">JavaScript中判断为整数的多种方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:JavaScript中判断为整数的多种方式 之前记录过JavaScript中判断为数字类型的多种方式,这篇看看如何判断为整数类型(Integer). JavaScript中不区分整数和浮点数,所有数字内部都采用64位浮点格式表示.但实际操作中比如数组索引.位操作则是基于32位整数. 方式一.使用取余运算符判断 任何整数都会被1整除,即余数是0.利用这个规则来判断是否是整数. function isInteger(obj) { return obj%1 === 0 } isInteger(3			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Rka6v3.html" rel="bookmark">javaScript中小数取整，四种方法的比较</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.parseInt:只取整数位例如:parseInt(3.7) 取整结果为:3parseInt(-1.1) 取整结果为:-1 2.Math.floor :向下去整,取大的整数例如:Math.floor(3.7) 取整结果为:4Math.floor(-1.1) 取整结果为:-1 3.Math.ceil :向上去整,取小的整数例如:Math.floor(3.7) 取整结果为:3Math.floor(-1.1) 取整结果为:-2 4.Math.round:四舍五入例如:Math.round(3.3)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kGzbd0.html" rel="bookmark">JavaScript中的各种奇葩问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:JavaScript中的各种奇葩问题 JavaScript浮点数 var a = (0.1 + 0.2) + 0.3; var b = 0.1 + (0.2 + 0.3); console.log(a);//0.6000000000000001 console.log(b);//0.6 在JavaScript中是没有整数的,所有数字都是双精度浮点数. 尽管JavaScript中缺少明显的整数类型,但是可以进行整数运算. 位算术运算符不会将操作数作为浮点数进行运算,而是会将其隐匿转换为32位			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41VwrvM.html" rel="bookmark">原生JavaScript判断是否为邮箱、危险字符、验证长度、验证网址、验证小数、整数、浮点数等常用的验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(71~80)验证篇这一篇文章主要是10个比较常用表单验证功能,包括了邮箱.危险字符.验证长度.验证网址.验证小数.整数.浮点数等常用的验证,有了这些代码片段,平时的表单验证也可以不需要jquery的验证插件了,希望可以帮到大家... 71.原生JavaScript判断是否为邮箱 复制代码 代码如下: function isEmail(str){ var re=/^\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pzNKg0.html" rel="bookmark">sql中取小数的整数部分和小数部分</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.floor()函数. select floor(3.44), 3.44-floor(3.44) 显示: 3     0.44 对于负数和正数这个函数处理的不一样. 对于正数不进行四舍五入.对于负数进行四舍五入. 2. select cast(12.3 as int), 12.3-cast(12.3  as int) select cast(-12.3 as int), -12.3+cast(-12.3  as int) 显示: 12     0.3 -12 -0.3 3. select le			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoZNdD4.html" rel="bookmark">正则表达式匹配字符串中是否的整数价格和小数价格</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				/**     * 匹配字符串中是否的整数价格和小数价格     * @param str     * @return     */    public static String Match_the_amount(String str) {        String pattern[] = {&quot;[1-9]\\d*\\u5143|[1-9]\\d*.\\d*\\u5143|0.\\d*[1-9]\\d*\\u5143|&quot;                + &quot;[1-9]\\d			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xBgYL4.html" rel="bookmark">了解 JavaScript 中的内置对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				所有编程语言都具有内部(或内置的)对象来创建 语言的基本功能.内部对象是 您编写自定义代码所用语言的基础, 该代码基于您的想象实现自定义功能.JavaScript 有许多 将其定义为语言的内部对象.本文介绍了一些 最常用的对象,并简要介绍了它们 有哪些功能以及如何使用这些功能. Number JavaScript Number 对象是 一个数值包装器.您可以将其与 new 关键词结合使用,并将其设置为一个稍后要在 JavaScript 代码中使用的变量: var myNumber = new N			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rBoog3.html" rel="bookmark">JavaScript 中常用的 正则表达式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这编文章我来整理了一些在 javascript 中常用的正则式希望能给大家带来一些开发的灵感 //校验是否全由数字组成 function isDigit(s) { var patrn=/^[0-9]{1,20}$/; if (!patrn.exec(s)) return false return true } 匹配中文字符的正则表达式: [u4e00-u9fa5]评注:匹配中文还真是个头疼的事,有了这个表达式就好办了 匹配双字节字符(包括汉字在内):[^x00-xff]评注:可以用来计算字符串的			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/N4pRnw0.html" rel="bookmark" class="title">php 基本概念，常规语法</a>
					<div>
						什么是php 一种服务器端的 HTML 脚本/编程语言,是一种简单的.面向对象的.解释型的.健 壮的.安全的.性能非常之高的.独立于架构的.可移植的.动态的脚本语言.是一种 广泛用于 Open Sou ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pvv5P0.html" rel="bookmark" class="title">学习搭建一个小网站&lowbar;3&lowbar;安装NodeJS模块&lowbar;建立express</a>
					<div>
						nodejs安装这些模块: express, express-generator, mongodb, mysql 简单步骤:建立目录 d:\js\BlogWebSite cmd-&gt;cd d:-& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lX7nE0.html" rel="bookmark" class="title">Microsoft Visual Studio International Pack 1&period;0 SR1--关于汉字转拼音</a>
					<div>
						Microsoft Visual Studio International Pack 1.0 SR1————微软的一个类库 地址:http://www.microsoft.com/zh-cn/down ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eqA950.html" rel="bookmark" class="title">Node&period;js v0&period;10&period;31API手冊-加密</a>
					<div>
						Node.js v0.10.31API手冊-文件夹 加密(Crypto) 使用 require('crypto') 来调用该模块. crypto模块提供在HTTPS或HTTP连接中封装安全凭证的方法. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoGGXkM.html" rel="bookmark" class="title">JAVA&lowbar;DataIO&lowbar;and&lowbar;ByteArrayIO</a>
					<div>
						1 import java.io.*; 2 public class TestDataStream { 3 public static void main(String[] args) { 4 Byt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0enZLZ3.html" rel="bookmark" class="title">查询自第一天到第七天的销售记录（累集N天）</a>
					<div>
						需求:查询商品(SKU)第一天到第七天的销售,第一天到第十四天的销售,-- 求解思路:1)查找SKU最早销售日期 2)查找第一天到第七天.第一天到第十四天销售数据 3)将这些数据的数量求和 在数据量达 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoGW7DM.html" rel="bookmark" class="title">FastBoot BootLoader Recovery 模式解释</a>
					<div>
						理论上,所有的Android设备都存在着Fastboot/Bootloader模式,不过,由于Android操作系统的开源特性,各厂商的对 自家的相关Android设备都有着各自不同的Fastboot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YYJWX0.html" rel="bookmark" class="title">COGS&mdash;&mdash;C2274&period; &lbrack;HEOI 2016&rsqb; tree</a>
					<div>
						http://www.cogs.pro/cogs/problem/problem.php?pid=2274 ★☆   输入文件:heoi2016_tree.in   输出文件:heoi2016_tre ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RDq1Y4.html" rel="bookmark" class="title">Unity3d的Sprite Packer用法介绍</a>
					<div>
						我们用来做sprite 的图片,通常会留有很多空白的地方,我们在画完了sprite之后,这些地方很可能就没有什么作用了.如果想避免这些资源上的浪费,我们可以把各个sprite做成图集,把图片上的空间尽 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/498N8n3.html" rel="bookmark" class="title">双向多对多</a>
					<div>
						1.在双方实体类里添加对方的集合 Emp实体类: public class Emp { private Integer nid; private String empname; Set&lt;Proj ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Y76JN4.html" rel="bookmark" class="title">AVPlayer 视频播放</a>
					<div>
						1. AVPlayer AVPlayer 是一个用来播放基于时间的视听媒体的控制器对象(一个队播放和资源时间相隔信息进行管理的对象,而非一个视图或窗口控制器). AVPlayer支持播放从本地, 分步 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZbKz83.html" rel="bookmark" class="title">K近邻算法</a>
					<div>
						1.1.什么是K近邻算法 何谓K近邻算法,即K-Nearest Neighbor algorithm,简称KNN算法,单从名字来猜想,可以简单粗暴的认为是:K个最近的邻居,当K=1时,算法便成了最近邻 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xZRen4.html" rel="bookmark" class="title">微信开发相关文档</a>
					<div>
						企业号开发者接口文档: http://qydev.weixin.qq.com/wiki 微信公众平台开发者文档 http://mp.weixin.qq.com/wiki/home/index.html ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dovmZM.html" rel="bookmark" class="title">作业 rh124</a>
					<div>
						1.新建用户并满足以下条件 1)asasin uid=2000 2) sareo  uid=2001 3) 这两个用户都属于deho组 4)这两个用户的密码为westos0ol1 5) 新建用户tar ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lkEXbM.html" rel="bookmark" class="title">hdoj2874 -- Connections between cities&lpar;LCA--tarjan离线&rpar;</a>
					<div>
						Connections between cities Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (J ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBxPqZ3.html" rel="bookmark" class="title">sql查询语句中的乱码 -- 前面加N</a>
					<div>
						直接运行sql出出现乱码,在中文字符前加N就能够正常显示了.N的含义就是用nvarchar格式显示.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d2xRe4.html" rel="bookmark" class="title">HDOJ 5007 Post Robot--2014网络赛西安赛区A题</a>
					<div>
						题目来源:http://acm.hdu.edu.cn/showproblem.php?pid=5007 Post Robot Time Limit: 2000/1000 MS (Java/Others ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoomOkM.html" rel="bookmark" class="title">JSP简单练习-用Servlet获取表单数据</a>
					<div>
						// javaBean代码 package servlet; import java.io.*; import javax.servlet.*; import javax.servlet.http.* ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmmJ61M.html" rel="bookmark" class="title">mybatis-ehcache 用法配置备忘</a>
					<div>
						1.配置ehcache文件: &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt; &lt;ehcache updateCh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVR66kM.html" rel="bookmark" class="title">js如何判断一个数组中是否有重复的值</a>
					<div>
						引自:http://bbs.tianya.cn/post-414-38497-1.shtml 方法一: var ary = new Array(&quot;111&quot;,&quot;22&quo ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
